package xyz.zhouxy.plusone.exception.handler;

import org.springframework.boot.autoconfigure.condition.ConditionalOnProperty;
import org.springframework.http.ResponseEntity;
import org.springframework.web.bind.annotation.ExceptionHandler;
import org.springframework.web.bind.annotation.RestControllerAdvice;

import lombok.extern.slf4j.Slf4j;
import xyz.zhouxy.plusone.util.RestfulResult;

/**
 * 处理所有异常的处理器
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@ConditionalOnProperty(prefix = "plusone.exception", name = "handle-all-exception", havingValue = "true")
@RestControllerAdvice
@Slf4j
public class AllExceptionHandler extends BaseExceptionHandler {
    protected AllExceptionHandler(ExceptionInfoHolder exceptionInfoHolder) {
        super(exceptionInfoHolder);
    }

    @ExceptionHandler(Exception.class)
    public ResponseEntity<RestfulResult> handleException(Throwable e) {
        log.error(e.getMessage(), e);
        return this.buildExceptionResponse(e);
    }
}
