package xyz.zhouxy.plusone.exception;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ResponseStatus;

/**
 * 需要时，当查询数据不存在时抛出的异常
 *
 * <p>
 * 暂时先这样，后续完善异常体系时可能会更改。
 * </p>
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 * @see xyz.zhouxy.plusone.util.AssertResult
 */
@ResponseStatus(HttpStatus.NOT_FOUND)
public class DataNotExistException extends PlusoneException {

    @java.io.Serial
    private static final long serialVersionUID = 6536955800679703111L;

    public static final int ERROR_CODE = 4110100;

    public DataNotExistException() {
        super(ERROR_CODE, "数据不存在");
    }

    public DataNotExistException(String message) {
        super(ERROR_CODE, message);
    }
}
