package xyz.zhouxy.plusone.exception;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ResponseStatus;

/**
 * 需要时，当数据操作的行数不符合预期时抛出的异常
 *
 * <p>
 * 暂时先这样，后续完善异常体系时可能会更改。
 * </p>
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 * @see xyz.zhouxy.plusone.util.AssertResult
 */
@ResponseStatus(HttpStatus.INTERNAL_SERVER_ERROR)
public class DataOperationNumberException extends PlusoneException {

    @java.io.Serial
    private static final long serialVersionUID = -9220765735990318186L;

    public static final int ERROR_CODE = 4110200;

    public DataOperationNumberException() {
        super(ERROR_CODE, "数据操作的行数不符合预期");
    }

    public DataOperationNumberException(String message) {
        super(ERROR_CODE, message);
    }
}
