package xyz.zhouxy.plusone.exception;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ResponseStatus;

/**
 * 4040600 - 用户操作异常
 *
 * @author ZhouXY
 */
@ResponseStatus(HttpStatus.BAD_REQUEST)
public class UserOperationException extends PlusoneException {

    @java.io.Serial
    private static final long serialVersionUID = 4371055414421991940L;

    public static final int DEFAULT_ERROR_CODE = 4040600;

    public UserOperationException(String msg) {
        super(DEFAULT_ERROR_CODE, msg);
    }

    public UserOperationException(String msg, Throwable cause) {
        super(DEFAULT_ERROR_CODE, msg, cause);
    }

    public UserOperationException(int code, String msg) {
        super(code, msg);
    }

    public UserOperationException(int code, Throwable cause) {
        super(code, cause);
    }

    public UserOperationException(int code, String msg, Throwable cause) {
        super(code, msg, cause);
    }

    /**
     * 无效的操作
     *
     * @return 异常对象
     */
    public static UserOperationException invalidOperation() {
        return invalidOperation("无效的操作");
    }

    /**
     * 无效的操作
     *
     * @param msg 异常信息
     * @return 异常对象
     */
    public static UserOperationException invalidOperation(String msg) {
        return new UserOperationException(4040604, msg);
    }

}
