package xyz.zhouxy.plusone.util;


import xyz.zhouxy.plusone.exception.DataNotExistException;
import xyz.zhouxy.plusone.exception.DataOperationNumberException;

import java.util.Objects;

/**
 * 对数据库执行结果进行判断
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public final class AssertResult {

    private AssertResult() {
        throw new IllegalStateException("Utility class");
    }

    public static void update(boolean expression) {
        if (!expression) {
            throw new DataOperationNumberException();
        }
    }

    public static void update(boolean expression, String message) {
        if (!expression) {
            throw new DataOperationNumberException(message);
        }
    }

    public static void update(Object i, int expectedValue) {
        if (!Objects.equals(i, expectedValue)) {
            throw new DataOperationNumberException();
        }
    }

    public static void update(Object i, int expectedValue, String format) {
        if (!Objects.equals(i, expectedValue)) {
            throw new DataOperationNumberException(String.format(format, i));
        }
    }

    public static void exist(boolean expression) {
        if (!expression) {
            throw new DataNotExistException();
        }
    }

    public static void exist(boolean expression, String message) {
        if (!expression) {
            throw new DataNotExistException(message);
        }
    }

    public static void nonNull(Object obj) {
        if (Objects.isNull(obj)) {
            throw new DataNotExistException();
        }
    }

    public static void nonNull(Object obj, String message) {
        if (Objects.isNull(obj)) {
            throw new DataNotExistException(message);
        }
    }
}
