package xyz.zhouxy.plusone.util;

import java.util.Objects;
import java.util.regex.Pattern;

import org.springframework.util.Assert;
import org.springframework.util.StringUtils;

/**
 * 字符串工具类
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public class PlusoneStrUtil {

    private PlusoneStrUtil() {
        throw new IllegalStateException("Utility class");
    }

    public static final String EMPTY_STR = "";

    public static String getTextOrEmpty(String value) {
        return StringUtils.hasText(value) ? value : EMPTY_STR;
    }

    public static String getStrOrEmpty(String value) {
        return StringUtils.hasLength(value) ? value : EMPTY_STR;
    }

    public static String checkString(String value, String regex, String message) {
        Assert.notNull(value, message);
        Assert.isTrue(Pattern.matches(regex, value), message);
        return value;
    }

    public static String checkStringNullable(String value, String regex, String message) {
        return Objects.nonNull(value) ? checkString(value, regex, message) : null;
    }

    public static String checkStringOrDefault(String value, String regex, String message) {
        return StringUtils.hasText(value) ? checkString(value, regex, message) : "";
    }
}
