package xyz.zhouxy.plusone.constant;

import xyz.zhouxy.plusone.util.Enumeration;
import xyz.zhouxy.plusone.util.EnumerationValuesHolder;

/**
 * 实体状态
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public class EntityStatus extends Enumeration<EntityStatus> {

    private EntityStatus(int value, String name) {
        super(value, name);
    }

    // 常量
    public static final EntityStatus AVAILABLE = new EntityStatus(0, "正常");
    public static final EntityStatus DISABLED = new EntityStatus(1, "禁用");

    private static final EnumerationValuesHolder<EntityStatus> ENUMERATION_VALUES = new EnumerationValuesHolder<>(
            new EntityStatus[] { AVAILABLE, DISABLED });

    public static EntityStatus of(int value) {
        return ENUMERATION_VALUES.get(value);
    }

    @Override
    public String toString() {
        return "EntityStatus" + super.toString();
    }
}
