package xyz.zhouxy.plusone.domain;

import cn.hutool.core.lang.UUID;
import lombok.Getter;

/**
 * 领域事件
 *
 * <p>
 * <b>根据所使用的消息机制的不同，可能需要继承其它类，或实现 {@link java.io.Serializable} 接口</b>
 * </p>
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 * @see Entity
 * @see IEventHandler
 */
@Getter
public abstract class DomainEvent {
    private String identifier;
    private long happenedAt;

    protected DomainEvent() {
        this.identifier = UUID.randomUUID().toString(true);
        this.happenedAt = System.currentTimeMillis();
    }
}
