package xyz.zhouxy.plusone.domain;

import java.util.Comparator;
import java.util.Objects;

/**
 * 带 orderNumber 字段，可用来排序
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public interface IWithOrderNumber extends Comparable<IWithOrderNumber> {

    int getOrderNumber();

    @Override
    default int compareTo(IWithOrderNumber that) {
        return new OrderNumberComparator<IWithOrderNumber>().compare(this, that);
    }

    class OrderNumberComparator<T extends Comparable<T>>
            implements Comparator<IWithOrderNumber> {
        @Override
        public int compare(IWithOrderNumber a, IWithOrderNumber b) {
            if (Objects.equals(a, b)) {
                return 0;
            }
            if (a == null) {
                return -1;
            }
            return (b == null) ? 1 : Integer.compare(a.getOrderNumber(), b.getOrderNumber());
        }
    }
}
