package xyz.zhouxy.plusone.domain;

import com.fasterxml.jackson.annotation.JsonIgnore;
import com.fasterxml.jackson.annotation.JsonValue;

/**
 * 带校验的字符串值对象
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public abstract class ValidatableStringRecord implements IValueObject {

    protected String value;
    protected final String format;

    protected ValidatableStringRecord(String format) {
        this.format = format;
    }

    @JsonIgnore
    protected boolean isValid() {
        return value.matches(format);
    }

    @JsonValue
    public String value() {
        return value;
    }

    @Override
    public String toString() {
        return value;
    }
}
