package xyz.zhouxy.plusone.jdbc;

import org.springframework.jdbc.core.JdbcTemplate;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;

import xyz.zhouxy.plusone.spring.SpringContextHolder;

/**
 * 全局单例，由 Spring 装配好的对象。
 * 可通过静态方法获取 Spring 容器中的 {@link JdbcTemplate} 和
 * {@link NamedParameterJdbcTemplate} 对象。
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 * @see JdbcTemplate
 * @see NamedParameterJdbcTemplate
 */
public final class JdbcFactory {

    private JdbcFactory() {
        throw new IllegalStateException("Utility class");
    }

    public static JdbcTemplate getJdbcTemplate() {
        return SpringContextHolder.getContext().getBean(JdbcTemplate.class);
    }

    public static NamedParameterJdbcTemplate getNamedParameterJdbcTemplate() {
        return SpringContextHolder.getContext().getBean(NamedParameterJdbcTemplate.class);
    }
}
