package xyz.zhouxy.plusone.jdbc.common;

import java.sql.ResultSet;
import java.sql.SQLException;

import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.RowMapper;

public class SimpleResultMapper<T> implements ResultMapper<T> {

    private final RowMapper<T> rowMapper;

    public SimpleResultMapper(RowMapper<T> rowMapper) {
        this.rowMapper = rowMapper;
    }

    @Override
    public T map(ResultSet resultSet) throws SQLException {
        return rowMapper.mapRow(resultSet, 1);
    }

    @Override
    public T rowMapper(ResultSet resultSet, int rowNum) throws SQLException {
        return this.rowMapper.mapRow(resultSet, rowNum);
    }

    public static <T> SimpleResultMapper<T> of(Class<T> clazz) {
        return new SimpleResultMapper<>(new BeanPropertyRowMapper<>(clazz));
    }
}
