package xyz.zhouxy.plusone.mail;

import org.springframework.mail.SimpleMailMessage;

/**
 * 构建 {@link SimpleMailMessage}
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public class MailMessageFactory {
    private final PlusoneMailProperties mailProperties;

    public MailMessageFactory(PlusoneMailProperties mailProperties) {
        this.mailProperties = mailProperties;
    }

    public SimpleMailMessage getCodeMailMessage(String code, String to) {
        String subject = mailProperties.getSubject().get("code");
        String content = String.format(mailProperties.getTemplate().get("code"), code);
        return getSimpleMailMessage(to, subject, content);
    }

    public SimpleMailMessage getSimpleMailMessage(String to, String subject, String content) {
        SimpleMailMessage simpleMailMessage = new SimpleMailMessage();
        simpleMailMessage.setFrom(mailProperties.getFrom());
        simpleMailMessage.setTo(to);
        simpleMailMessage.setSubject(subject);
        simpleMailMessage.setText(content);
        return simpleMailMessage;
    }
}
