package xyz.zhouxy.plusone.mail;

import org.springframework.boot.autoconfigure.EnableAutoConfiguration;
import org.springframework.boot.autoconfigure.condition.ConditionalOnClass;
import org.springframework.boot.context.properties.EnableConfigurationProperties;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;
import org.springframework.mail.javamail.JavaMailSender;

/**
 * 读取配置文件，实例化 {@link MailService} 对象后，放到 Spring 容器中。
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Configuration
@EnableConfigurationProperties(PlusoneMailProperties.class)
@ConditionalOnClass(MailService.class)
@EnableAutoConfiguration
public class PlusoneMailAutoConfiguration {

    @Bean
    public MailService mailService(JavaMailSender mailSender, PlusoneMailProperties mailProperties) {
        MailMessageFactory mailMessageFactory = new MailMessageFactory(mailProperties);
        return new SimpleMailService(mailSender, mailMessageFactory);
    }
}
