package xyz.zhouxy.plusone.sms;

import java.util.Map;

import org.springframework.boot.context.properties.ConfigurationProperties;

import lombok.Data;

/**
 * SMS 相关参数
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Data
@ConfigurationProperties("plusone.sms")
public class SmsProperties {
    private String region;
    private SmsCredentialProperties credential;
    private SmsClientProperties client;
    private String appId;
    private Map<String, String> templates;
}

@Data
@ConfigurationProperties("plusone.sms.credential")
class SmsCredentialProperties {
    private String secretId;
    private String secretKey;
}

@Data
@ConfigurationProperties("plusone.sms.client")
class SmsClientProperties {
    private String signMethod;
    private SmsHttpProperties http;
}

@Data
@ConfigurationProperties("plusone.sms.client.http")
class SmsHttpProperties {
    private SmsProxyProperties proxy;
    private String reqMethod;
    private Integer connTimeout;
}

@Data
@ConfigurationProperties("plusone.sms.client.http.proxy")
class SmsProxyProperties {
    private String host;
    private Integer port;
}
