package xyz.zhouxy.plusone.spring;

import org.springframework.context.ApplicationContext;
import org.springframework.context.annotation.Bean;
import org.springframework.context.annotation.Configuration;

public class SpringContextHolder {

    private ApplicationContext context;

    private static final SpringContextHolder INSTANCE = new SpringContextHolder();

    private SpringContextHolder() {
    }

    public static ApplicationContext getContext() {
        return INSTANCE.context;
    }

    @Configuration
    static class SpringContextHolderConfig {
        @Bean(name = "springContextHolder")
        SpringContextHolder getSpringContextHolder(ApplicationContext context) {
            SpringContextHolder.INSTANCE.context = context;
            return SpringContextHolder.INSTANCE;
        }
    }
}
