package xyz.zhouxy.plusone.sql;

import java.util.Objects;

import org.apache.ibatis.jdbc.AbstractSQL;

/**
 * 扩展 MyBatis 中的 SQL 语句构造器
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public class SQL extends AbstractSQL<SQL> {

    public SQL SET_IF(boolean condition, String sets) {
        return condition ? SET(sets) : getSelf();
    }

    public SQL SET_IF_NOT_NULL(Object param, String sets) {
        return Objects.nonNull(param) ? SET(sets) : getSelf();
    }

    public SQL WHERE_IF(boolean condition, String sqlCondition) {
        return condition ? WHERE(sqlCondition) : getSelf();
    }

    public SQL WHERE_IF_NOT_NULL(Object param, String sqlCondition) {
        return Objects.nonNull(param) ? WHERE(sqlCondition) : getSelf();
    }

    @Override
    public SQL getSelf() {
        return this;
    }
}
