package xyz.zhouxy.plusone.validatortest;

import org.junit.jupiter.api.Test;

import lombok.AllArgsConstructor;
import lombok.Data;
import lombok.NoArgsConstructor;
import xyz.zhouxy.plusone.constant.RegexConsts;
import xyz.zhouxy.plusone.validator.validator2.BaseValidator2;

class BaseValidator2Test {

    @Test
    void testValid() {
        LoginCommand loginCommand = new LoginCommand("13169053215@qq.com", "A1qZ6c-cQ78=^(", false);
        LoginCommandValidator.INSTANCE.validate(loginCommand);
        System.err.println(loginCommand);
    }
}

@Data
@NoArgsConstructor
@AllArgsConstructor
class LoginCommand {
    private String account;
    private String pwd;
    private boolean rememberMe;
}

class LoginCommandValidator extends BaseValidator2<LoginCommand> {

    public static final LoginCommandValidator INSTANCE = new LoginCommandValidator();

    private LoginCommandValidator() {
        ruleFor(LoginCommand::getAccount)
                .notNull("邮箱地址不能为空")
                .matchesOr(new String[] { RegexConsts.EMAIL, RegexConsts.MOBILE_PHONE }, value -> new RuntimeException('"' + value + "\" 不是邮箱地址或手机号"));
        ruleFor(LoginCommand::getPwd)
                .notNull("密码不能为空")
                .notEmpty("密码不能为空")
                .matches(RegexConsts.PASSWORD, "密码格式错误");
    }
}
