package xyz.zhouxy.plusone.system.application.controller;

import static xyz.zhouxy.plusone.system.constant.AuthLogic.adminAuthLogic;

import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RestController;

import xyz.zhouxy.plusone.system.application.service.AccountContextService;
import xyz.zhouxy.plusone.util.RestfulResult;

/**
 * 账号查询本身相关信息
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@RestController
@RequestMapping("account")
public class AccountContextController {

    private final AccountContextService service;

    public AccountContextController(AccountContextService service) {
        this.service = service;
    }

    @GetMapping("info")
    public RestfulResult getAccountInfo() {
        adminAuthLogic.checkLogin();
        var result = service.getAccountInfo();
        return RestfulResult.success("查询成功", result);
    }

    @GetMapping("menus")
    public RestfulResult getMenuTree() {
        adminAuthLogic.checkLogin();
        var result = service.getMenuTree();
        return RestfulResult.success("查询成功", result);
    }
}
