package xyz.zhouxy.plusone.system.application.exception;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ResponseStatus;

import xyz.zhouxy.plusone.exception.PlusoneException;

@ResponseStatus(HttpStatus.BAD_REQUEST)
public class AccountLoginException extends PlusoneException {
    @java.io.Serial
    private static final long serialVersionUID = -3040996790739138556L;

    private static final int DEFAULT_ERR_CODE = 4030000;

    private AccountLoginException() {
        super(DEFAULT_ERR_CODE, "用户登录异常");
    }

    private AccountLoginException(int code, String message) {
        super(code, message);
    }

    public static AccountLoginException accountNotExistException() {
        return new AccountLoginException(4030101, "用户账户不存在");
    }

    public static AccountLoginException otpErrorException() {
        return new AccountLoginException(4030501, "验证码错误");
    }

    public static AccountLoginException otpNotExistsException() {
        return new AccountLoginException(4030502, "验证码不存在或已过期");
    }

    public static AccountLoginException passwordErrorException() {
        return new AccountLoginException(4030200, "用户密码错误");
    }
}
