package xyz.zhouxy.plusone.system.application.exception;

import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.ResponseStatus;

import xyz.zhouxy.plusone.exception.PlusoneException;

@ResponseStatus(HttpStatus.BAD_REQUEST)
public class AccountRegisterException extends PlusoneException {

    @java.io.Serial
    private static final long serialVersionUID = 7580245181633370195L;

    public AccountRegisterException() {
        this(4020000, "用户注册错误");
    }

    public AccountRegisterException(String message) {
        this(4020000, message);
    }

    public AccountRegisterException(Throwable cause) {
        super(4020000, cause);
    }

    public AccountRegisterException(int code, String message) {
        super(code, message);
    }

    public AccountRegisterException(int code, Throwable cause) {
        super(code, cause);
    }

    public static AccountRegisterException emailOrMobilePhoneRequiredException() {
        return new AccountRegisterException(4020300, "邮箱和手机号应至少绑定一个");
    }

    public static AccountRegisterException usernameAlreadyExists(String username) {
        return new AccountRegisterException(4020400, String.format("用户名 %s 已存在", username));
    }

    public static AccountRegisterException emailAlreadyExists(String value) {
        return new AccountRegisterException(4020500, String.format("邮箱 %s 已存在", value));
    }

    public static AccountRegisterException mobilePhoneAlreadyExists(String value) {
        return new AccountRegisterException(4020600, String.format("手机号 %s 已存在", value));
    }

    public static AccountRegisterException codeErrorException() {
        return new AccountRegisterException(4020701, "校验码错误");
    }

    public static AccountRegisterException codeNotExistsException() {
        return new AccountRegisterException(4020702, "校验码不存在或已过期");
    }
}
