package xyz.zhouxy.plusone.system.application.query;

import java.util.List;

import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.namedparam.BeanPropertySqlParameterSource;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Component;

import xyz.zhouxy.plusone.sql.SQL;
import xyz.zhouxy.plusone.system.application.query.params.DictQueryParams;
import xyz.zhouxy.plusone.system.application.query.result.DictOverview;

/**
 * 数据字典查询器
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Component
public class DictQueries {

    private final NamedParameterJdbcTemplate jdbcTemplate;

    public DictQueries(NamedParameterJdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
    }

    public List<DictOverview> queryDictOverviewList(DictQueryParams queryParams) {
        String sql = new SQL()
                .SELECT("id", "dict_type", "dict_label",
                        "created_by", "create_time", "updated_by", "update_time", "count")
                .FROM("view_sys_dict_overview")
                .WHERE_IF(queryParams.getDictType() != null, "dict_type LIKE '%:dictType%'")
                .WHERE_IF(queryParams.getDictLabel() != null, "dict_label LIKE '%:dictLabel%'")
                .toString();
        return this.jdbcTemplate
                .query(sql, new BeanPropertySqlParameterSource(queryParams), new BeanPropertyRowMapper<>(DictOverview.class));
    }
}
