package xyz.zhouxy.plusone.system.application.query;

import java.util.List;

import org.springframework.jdbc.core.BeanPropertyRowMapper;
import org.springframework.jdbc.core.namedparam.BeanPropertySqlParameterSource;
import org.springframework.jdbc.core.namedparam.NamedParameterJdbcTemplate;
import org.springframework.stereotype.Repository;

import xyz.zhouxy.plusone.sql.SQL;
import xyz.zhouxy.plusone.system.application.query.params.RoleQueryParams;
import xyz.zhouxy.plusone.system.application.query.result.RoleOverview;

/**
 * 角色信息查询器
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Repository
public class RoleQueries {

    private final NamedParameterJdbcTemplate jdbcTemplate;

    public RoleQueries(NamedParameterJdbcTemplate jdbcTemplate) {
        this.jdbcTemplate = jdbcTemplate;
    }

    /**
     * 查询 Role
     * <p>
     * <b> ！！！注意：此方法内存在字符串拼接，勿在循环内使用。</b>
     * </p>
     *
     * @param params 查询参数
     * @return 查询结果
     */
    public List<RoleOverview> query(RoleQueryParams params) {
        String b = new SQL()
                .SELECT("id")
                .FROM("sys_role")
                .WHERE_IF_NOT_NULL(params.getId(), "id = :id")
                .WHERE_IF_NOT_NULL(params.getName(), "name = :name")
                .WHERE_IF_NOT_NULL(params.getIdentifier(), "identifier = :identifier")
                .WHERE_IF_NOT_NULL(params.getStatus(), "status = :status")
                .WHERE_IF_NOT_NULL(params.getCreateTimeStart(), "create_time >= :createTimeStart")
                .WHERE_IF_NOT_NULL(params.getCreateTimeEnd(), "create_time < :createTimeEnd")
                .WHERE_IF_NOT_NULL(params.getUpdateTimeStart(), "update_time >= :updateTimeStart")
                .WHERE_IF_NOT_NULL(params.getUpdateTimeEnd(), "update_time < :updateTimeEnd")
                .LIMIT(params.getSize())
                .OFFSET(params.getOffset())
                .toString();
        var sql = """
                SELECT a.id AS id, a.name AS name, a.identifier AS identifier, a.status AS status
                FROM sys_role AS a, (
                """ + b + """
                ) AS b
                WHERE a.id = b.id
                """;
        return this.jdbcTemplate
                .query(sql, new BeanPropertySqlParameterSource(params),
                        new BeanPropertyRowMapper<>(RoleOverview.class));
    }

}
