package xyz.zhouxy.plusone.system.application.service;

import static xyz.zhouxy.plusone.system.constant.AuthLogic.adminAuthLogic;

import java.util.List;

import org.springframework.stereotype.Service;

import xyz.zhouxy.plusone.system.application.query.AccountQueries;
import xyz.zhouxy.plusone.system.application.query.result.AccountDetails;
import xyz.zhouxy.plusone.system.application.query.result.MenuViewObject;

/**
 * 账号查询本身相关信息
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Service
public class AccountContextService {

    private final AccountQueries accountQueries;
    private final MenuManagementService menuManagementService;

    public AccountContextService(AccountQueries accountQueries, MenuManagementService menuManagementService) {
        this.accountQueries = accountQueries;
        this.menuManagementService = menuManagementService;
    }

    public AccountDetails getAccountInfo() {
        long accountId = adminAuthLogic.getLoginIdAsLong();
        return accountQueries.queryAccountDetails(accountId);
    }

    public List<MenuViewObject> getMenuTree() {
        long accountId = adminAuthLogic.getLoginIdAsLong();
        return menuManagementService.queryByAccountId(accountId);
    }
}
