package xyz.zhouxy.plusone.system.application.service.command;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.NotNull;

import lombok.Getter;
import lombok.Setter;
import xyz.zhouxy.plusone.constant.EntityStatus;
import xyz.zhouxy.plusone.domain.ICommand;
import xyz.zhouxy.plusone.system.domain.model.menu.Menu.MenuType;

/**
 * 创建菜单命令
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Getter
@Setter
public class CreateMenuCommand implements ICommand {
    @NotNull
    private MenuType menuType;

    @NotNull
    private Long parentId;

    @NotBlank
    private String path;

    @NotBlank
    private String name;

    @NotBlank
    private String title;

    @NotBlank
    private String icon;

    @NotNull
    private Boolean hidden;

    @NotNull
    private Integer orderNumber;

    @NotNull
    private EntityStatus status;

    private String component;

    private String resource;

    @NotNull
    private Boolean cache;

    private String remarks;
}
