package xyz.zhouxy.plusone.system.application.service.command;

import javax.validation.constraints.NotBlank;
import javax.validation.constraints.Pattern;

import org.hibernate.validator.constraints.URL;

import lombok.Data;
import xyz.zhouxy.plusone.constant.RegexConsts;
import xyz.zhouxy.plusone.domain.ICommand;
import xyz.zhouxy.plusone.system.domain.model.account.Sex;

/**
 * 注册账号命令
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Data
public class RegisterAccountCommand implements ICommand {

    @NotBlank
    String emailOrMobilePhone;

    @NotBlank
    @Pattern(regexp = RegexConsts.CAPTCHA)
    String code; // 校验码

    @NotBlank
    @Pattern(regexp = RegexConsts.USERNAME)
    String username;

    @NotBlank
    @Pattern(regexp = RegexConsts.PASSWORD)
    String password;
    String passwordConfirmation;

    @Pattern(regexp = RegexConsts.NICKNAME)
    String nickname;

    @NotBlank
    @URL
    String avatar;

    Sex sex;
}
