package xyz.zhouxy.plusone.system.application.service.command;

import javax.validation.constraints.NotNull;
import javax.validation.constraints.Pattern;

import org.hibernate.validator.constraints.URL;

import lombok.Data;
import xyz.zhouxy.plusone.constant.RegexConsts;
import xyz.zhouxy.plusone.domain.ICommand;
import xyz.zhouxy.plusone.system.domain.model.account.Sex;

/**
 * 更新账号信息命令
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Data
public class UpdateAccountCommand implements ICommand {

    @NotNull
    Long id;

    @Pattern(regexp = RegexConsts.NICKNAME)
    String nickname;

    @URL
    String avatar;

    Sex sex;
}
