package xyz.zhouxy.plusone.system.application.service.command.validator;

import java.util.regex.Pattern;

import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import xyz.zhouxy.plusone.constant.RegexConsts;
import xyz.zhouxy.plusone.system.application.service.command.LoginByOtpCommand;
import xyz.zhouxy.plusone.util.RegexUtil;
import xyz.zhouxy.plusone.validator.BaseValidator;
import xyz.zhouxy.plusone.validator.DtoValidator;

@Component
@DtoValidator(LoginByOtpCommand.class)
public class LoginByOtpCommandValidator extends BaseValidator<LoginByOtpCommand> {
    public LoginByOtpCommandValidator() {
        withRule(loginCommand -> {
            String principal = loginCommand.getPrincipal();
            return StringUtils.hasText(principal)
                    &&
                    RegexUtil.matchesOr(principal, RegexConsts.EMAIL, RegexConsts.MOBILE_PHONE);
        }, "输入邮箱地址或手机号");
        withRule(loginCommand -> {
            String otp = loginCommand.getOtp();
            return StringUtils.hasText(otp) && Pattern.matches(RegexConsts.CAPTCHA, otp);
        }, "验证码不符合要求");
    }
}
