package xyz.zhouxy.plusone.system.application.service.command.validator;

import java.util.regex.Pattern;

import org.springframework.stereotype.Component;
import org.springframework.util.StringUtils;

import xyz.zhouxy.plusone.constant.RegexConsts;
import xyz.zhouxy.plusone.system.application.service.command.LoginByPasswordCommand;
import xyz.zhouxy.plusone.util.RegexUtil;
import xyz.zhouxy.plusone.validator.BaseValidator;
import xyz.zhouxy.plusone.validator.DtoValidator;

@Component
@DtoValidator(LoginByPasswordCommand.class)
public class LoginByPasswordCommandValidator extends BaseValidator<LoginByPasswordCommand> {
    public LoginByPasswordCommandValidator() {
        withRule(loginCommand -> {
            String principal = loginCommand.getPrincipal();
            return StringUtils.hasText(principal)
                    &&
                    RegexUtil.matchesOr(principal, RegexConsts.USERNAME, RegexConsts.EMAIL, RegexConsts.MOBILE_PHONE, principal);
        }, "输入用户名、邮箱地址或手机号");
        withRule(loginCommand -> {
            String password = loginCommand.getPassword();
            return StringUtils.hasText(password)
                    &&
                    Pattern.matches(RegexConsts.PASSWORD, password);
        }, "密码格式不正确");
    }
}
