package xyz.zhouxy.plusone.system.domain.event;

import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;
import lombok.ToString;
import xyz.zhouxy.plusone.domain.DomainEvent;
import xyz.zhouxy.plusone.system.domain.model.account.Account;
import xyz.zhouxy.plusone.system.domain.model.account.Email;
import xyz.zhouxy.plusone.system.domain.model.account.MobilePhone;
import xyz.zhouxy.plusone.system.domain.model.account.Username;

/**
 * 领域事件：账号用户名修改事件
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Getter
@Setter
@NoArgsConstructor
@ToString(callSuper = true)
public class UsernameChanged extends DomainEvent {

    private Username username;
    private Email email;
    private MobilePhone mobilePhone;

    public UsernameChanged(Account account) {
        this.username = account.getUsername();
        this.email = account.getEmail();
        this.mobilePhone = account.getMobilePhone();
    }
}
