package xyz.zhouxy.plusone.system.domain.model.account;

import lombok.Getter;
import xyz.zhouxy.plusone.domain.IValueObject;
import xyz.zhouxy.plusone.util.Enumeration;
import xyz.zhouxy.plusone.util.EnumerationValuesHolder;

/**
 * 账号状态
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Getter
public class AccountStatus extends Enumeration<AccountStatus> implements IValueObject {

    private AccountStatus(int value, String name) {
        super(value, name);
    }

    public static final AccountStatus AVAILABLE = new AccountStatus(0, "账号正常");
    public static final AccountStatus LOCKED = new AccountStatus(1, "账号被锁定");

    private static final EnumerationValuesHolder<AccountStatus> ENUMERATION_VALUES = new EnumerationValuesHolder<>(
            new AccountStatus[] { AVAILABLE, LOCKED });

    public static AccountStatus of(int value) {
        return ENUMERATION_VALUES.get(value);
    }
}
