package xyz.zhouxy.plusone.system.domain.model.account;

import java.util.Objects;

import xyz.zhouxy.plusone.constant.RegexConsts;
import xyz.zhouxy.plusone.domain.ValidatableStringRecord;

/**
 * 值对象：昵称
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public class Nickname extends ValidatableStringRecord {

    public static final String REGEX = RegexConsts.NICKNAME;

    private Nickname(String value) {
        super(REGEX);
        if (value == null) {
            throw new IllegalArgumentException("昵称不能为空");
        }
        this.value = value;
        if (!isValid()) {
            throw new IllegalArgumentException("昵称格式错误");
        }
    }

    public static Nickname of(String nickname) {
        return new Nickname(nickname);
    }

    public static Nickname ofNullable(String nickname) {
        return Objects.nonNull(nickname) ? new Nickname(nickname) : null;
    }
}
