package xyz.zhouxy.plusone.system.domain.model.account;

import xyz.zhouxy.plusone.constant.RegexConsts;

/**
 * 值对象：用户名
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public class Username extends Principal {

    public static final String REGEX = RegexConsts.USERNAME;

    private Username(String username) {
        super(REGEX);
        if (username == null) {
            throw new IllegalArgumentException("用户名不能为空");
        }
        this.value = username;
        if (!isValid()) {
            throw new IllegalArgumentException("用户名格式错误");
        }
    }

    public static Username of(String username) {
        return new Username(username);
    }
}
