package xyz.zhouxy.plusone.system.domain.model.dict;

import java.util.Objects;

import lombok.Getter;
import lombok.ToString;
import xyz.zhouxy.plusone.domain.IValueObject;

/**
 * 字典值
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
@Getter
@ToString
public class DictValue implements IValueObject {

    final Integer key;
    String label;

    // ==================== 实例化 ====================

    private DictValue(int key, String label) {
        this.key = key;
        this.label = label;
    }

    public static DictValue of(int key, String label) {
        return new DictValue(key, label);
    }

    @Override
    public int hashCode() {
        return Objects.hash(key);
    }

    @Override
    public boolean equals(Object obj) {
        if (this == obj) {
            return true;
        }
        if (obj == null) {
            return false;
        }
        if (getClass() != obj.getClass()) {
            return false;
        }
        DictValue other = (DictValue) obj;
        return Objects.equals(key, other.key);
    }
}
