package xyz.zhouxy.plusone.system.domain.model.menu;

import java.util.List;

import xyz.zhouxy.plusone.constant.EntityStatus;
import xyz.zhouxy.plusone.system.domain.model.menu.Menu.MenuType;

/**
 * 菜单构造器。生成新的 MenuList 或 MenuItem
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public class MenuConstructor {

    private MenuConstructor() {
        throw new IllegalStateException("Utility class");
    }

    public static Menu newMenuItem(
            long parentId,
            String path,
            String name,
            String title,
            String icon,
            boolean hidden,
            int orderNumber,
            EntityStatus status,
            String component,
            String resource,
            boolean cache,
            String remarks) {
        List<Action> actions = List.of(
                Action.newInstance(resource, "-query", "查询"),
                Action.newInstance(resource, "-details", "详情"),
                Action.newInstance(resource, "-add", "新增"),
                Action.newInstance(resource, "-update", "修改"),
                Action.newInstance(resource, "-delete", "删除"));
        return new Menu(MenuType.MENU_ITEM, null, parentId, name, path, title, icon, hidden, orderNumber, status,
                remarks, component, cache, resource, actions, 0L);
    }

    public static Menu newMenuList(
            long parentId,
            String path,
            String name,
            String title,
            String icon,
            boolean hidden,
            int orderNumber,
            EntityStatus status,
            String remarks) {
        return new Menu(MenuType.MENU_LIST, null, parentId, name, path, title, icon, hidden, orderNumber, status,
                remarks, null, null, null, null, 0L);
    }
}
