package xyz.zhouxy.plusone.system.domain.model.permission;

import java.util.Optional;

import lombok.Getter;
import xyz.zhouxy.plusone.domain.Entity;
import xyz.zhouxy.plusone.domain.IWithLabel;
import xyz.zhouxy.plusone.domain.IWithVersion;

/**
 * 行为
 *
 * @author <a href="https://gitee.com/zhouxy108">ZhouXY</a>
 */
public class Action extends Entity<Long> implements IWithLabel, IWithVersion {

    Long id;
    String resource;
    @Getter String identifier;
    @Getter String label;
    @Getter long version;

    public Action(Long id, String resource, String identifier, String label, long version) {
        this.id = id;
        this.resource = resource;
        this.identifier = identifier;
        this.label = label;
        this.version = version;
    }

    static Action newInstance(String resource, String identifier, String label) {
        return new Action(null, resource, identifier, label, 0L);
    }

    static Action existingInstance(Long id, String resource, String action, String label, Long version) {
        return new Action(id, resource, action, label, version);
    }

    public String value() {
        return resource + identifier;
    }

    @Override
    public Optional<Long> getId() {
        return Optional.ofNullable(id);
    }
}
